package beispielmituilookandfeel;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.sound.*;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.AudioSystem;

public class FrameJS extends JFrame {
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  Border border1;
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton jButtonAbfragen = new JButton();
  JButton jButtonClear = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextAreaErgebnis = new JTextArea();

  //Construct the frame
  public FrameJS() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142));
    this.setSize(new Dimension(400, 300));
    this.setTitle("JavaSound Beispiel 1");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    jButtonAbfragen.setText("Abfragen");
    jButtonClear.setText("Clear");
    jButtonClear.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        jButtonClear_mousePressed(e);
      }
    });
    jTextAreaErgebnis.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        jTextAreaErgebnis_mousePressed(e);
      }
    });
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    contentPane.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jButtonAbfragen, null);
    jPanel1.add(jButtonClear, null);
    contentPane.add(jPanel2, BorderLayout.SOUTH);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextAreaErgebnis, null);
    this.setJMenuBar(menuBar1);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    FrameJS_AboutBox dlg = new FrameJS_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void jTextAreaErgebnis_mousePressed(MouseEvent e) {
    		Mixer.Info[]	mi;

		String			s;
		mi = AudioSystem.getMixerInfo();

		for (int i=0;i<mi.length;i++)
		{
			s = mi[i].toString();
			System.out.println(s);
                        jTextAreaErgebnis.setText(s);
		}

  }

  void jButtonClear_mousePressed(MouseEvent e) {
    jTextAreaErgebnis.setText("");
    jTextAreaErgebnis.setText("Ergebnisbereich wurde geleert!");
  }
}