package beispielmituilookandfeel;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.sound.*;
import javax.sound.sampled.Mixer;
import javax.sound.sampled.AudioSystem;

public class FrameSound1 extends JFrame {
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  JLabel statusBar = new JLabel();
  JPanel jPanel1 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea jTextAreaErgebnisse = new JTextArea();
  JButton jButtonAbfragen = new JButton();
  JButton jButtonClear = new JButton();

  //Construct the frame
  public FrameSound1() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    this.setSize(new Dimension(400, 300));
    this.setTitle("JavaSound - Sound 1");
    statusBar.setText(" ");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        fileExit_actionPerformed(e);
      }
    });
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new ActionListener()  {

      public void actionPerformed(ActionEvent e) {
        helpAbout_actionPerformed(e);
      }
    });
    jButtonAbfragen.setText("Abfragen");
    jButtonAbfragen.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        jButtonAbfragen_mousePressed(e);
      }
    });
    jButtonClear.setText("Clear");
    jButtonClear.addMouseListener(new java.awt.event.MouseAdapter() {

      public void mousePressed(MouseEvent e) {
        jButtonClear_mousePressed(e);
      }
    });
    jButtonClear.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        jButtonClear_actionPerformed(e);
      }
    });
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(statusBar, BorderLayout.SOUTH);
    contentPane.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jButtonAbfragen, null);
    jPanel1.add(jButtonClear, null);
    contentPane.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jTextAreaErgebnisse, null);
  }

  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    FrameSound1_AboutBox dlg = new FrameSound1_AboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void jButtonClear_actionPerformed(ActionEvent e) {

  }

  void jButtonAbfragen_mousePressed(MouseEvent e) {
    jTextAreaErgebnisse.setText("Abfrage der Soundkarte");
    statusBar.setText("Abfrage ist im Gange .... ");
    Mixer.Info[]	mi;

    String			s="";
    mi = AudioSystem.getMixerInfo();

    for (int i=0;i<mi.length;i++){
	s = s+mi[i].toString()+"\n";
	System.out.println(s); // Ausgabe ins Log der Konsole
    }
    jTextAreaErgebnisse.setText(s);


    statusBar.setText("Abfrage ist abgeschlossen [die Ergebnisse stehen im TextFenster] !");
  }

  void jButtonClear_mousePressed(MouseEvent e) {
    jTextAreaErgebnisse.setText("");
    jTextAreaErgebnisse.setText("Ergebnisse wurden gelscht");
    statusBar.setText("War's das?");
  }
}