package menubar;

import java.awt.*;
import java.awt.event.*;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

class Hauptmenu extends MenuBar {
   private MenuItem miRueck;
   private CheckboxMenuItem miFarbe;

   public Hauptmenu()   {
      Menu m;

      //Datei
      m = new Menu("Datei");
      m.add(new MenuItem("Neu"));
      m.add(new MenuItem("Laden"));
      m.add(new MenuItem("Speichern"));
      m.addSeparator();
      m.add(new MenuItem("Beenden"));
      add(m);
      //Bearbeiten
      m = new Menu("Bearbeiten");
      m.add((miRueck = new MenuItem("Rueckgaengig")));
      m.addSeparator();
      m.add(new MenuItem("Ausschneiden"));
      m.add(new MenuItem("Kopieren"));
      m.add(new MenuItem("Einfuegen"));
      m.add(new MenuItem("Loeschen"));
      add(m);
      //Optionen
      m = new Menu("Optionen");
      m.add(new MenuItem("Einstellungen"));
      m.add((miFarbe = new CheckboxMenuItem("Farbe")));
      add(m);
      //Rueckgaengig deaktivieren
      enableRueckgaengig(false);
      //Farbe anschalten
      setFarbe(true);
      //Hilfe
      m = new Menu("Hilfe");
      m.add(new MenuItem("About"));
      this.setHelpMenu(m);
      add(m);
   }

   public void enableRueckgaengig(boolean ena)
   {
      if (ena) {
         miRueck.setEnabled(true);
      } else {
         miRueck.setEnabled(false);
      }
   }

   public void setFarbe(boolean on)
   {
      miFarbe.setState(on);
   }
}

public class MenuBarBeispiel
extends Frame
{
   public static void main(String[] args)
   {
      MenuBarBeispiel wnd = new MenuBarBeispiel();
   }

   public MenuBarBeispiel()
   {
      super("MenuBar Beispiel");
      setLocation(100,100);
      setSize(400,300);
      setMenuBar(new Hauptmenu());
      setVisible(true);
      addWindowListener(
         new WindowAdapter() {
            public void windowClosing(WindowEvent event)
            {
               setVisible(false);
               dispose();
               System.exit(0);
            }
         }
      );
   }
}
