package zeichnenundserialisieren;

import java.awt.*;
import java.awt.event.*;
//import java.applet.*;
import java.util.*;
/**
 * Title:        Zeichnen und Serialisieren
 * Description:   nicht fertig!!!!!!!
 * Copyright:    Copyright (C) J.M.Joller
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */
class ZeichnenPanel extends Panel implements MouseListener, MouseMotionListener {
    // Kodierung des Zeichenmodus
    public static final int LINIEN = 0;
    public static final int PUNKTE = 1;
    int	   zeichnungsModus = LINIEN;
    Vector linien = new Vector();
    Vector farben = new Vector();
    int x1,y1;
    int x2,y2;

    public ZeichnenPanel() {
	setBackground(Color.white);
	addMouseMotionListener(this);
	addMouseListener(this);
    }

    public void setzenDesZeichnungsModus(int zeichnungsModus) {
	switch (zeichnungsModus) {
	  case LINIEN:
	  case PUNKTE:
	    this.zeichnungsModus = zeichnungsModus;
	    break;
	  default:
	    throw new IllegalArgumentException();
	}
    }


    public void mouseDragged(MouseEvent e) {
        // Event Tracking : ignoriere das MausDragging
        e.consume();
        switch (zeichnungsModus) {
            case LINIEN:
                x2 = e.getX();
                y2 = e.getY();
                break;
            case PUNKTE:
            default:
                farben.addElement(getForeground());
                linien.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                x1 = e.getX();
                y1 = e.getY();
                break;
        }
        repaint();
    }

    public void mouseMoved(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
        // Event Tracking : ignoriere MousePressed
        e.consume();
        switch (zeichnungsModus) {
            case LINIEN:
                x1 = e.getX();
                y1 = e.getY();
                x2 = -1;
                break;
            case PUNKTE:
            default:
                farben.addElement(getForeground());
                linien.addElement(new Rectangle(e.getX(), e.getY(), -1, -1));
                x1 = e.getX();
                y1 = e.getY();
                repaint();
                break;
        }
    }

    public void mouseReleased(MouseEvent e) {
      // Event Tracking
        e.consume();
        switch (zeichnungsModus) {
            case LINIEN:
                farben.addElement(getForeground());
                linien.addElement(new Rectangle(x1, y1, e.getX(), e.getY()));
                x2 = -1;
                break;
            case PUNKTE:
            default:
                break;
        }
        repaint();
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
    }

    public void paint(Graphics g) {
	int np = linien.size();

	/* aktuelle Linie zeichnen */
	g.setColor(getForeground());
	for (int i=0; i < np; i++) {
	    Rectangle p = (Rectangle)linien.elementAt(i);
	    g.setColor((Color)farben.elementAt(i));
	    if (p.width != -1) {
		g.drawLine(p.x, p.y, p.width, p.height);
	    } else {
		g.drawLine(p.x, p.y, p.x, p.y);
	    }
	}
	if (zeichnungsModus == LINIEN) {
	    g.setColor(getForeground());
	    if (x2 != -1) {
                g.drawLine(x1, y1, x2, y2);
	    }
	}
    }
}