package zeichnenundserialisieren;

import javax.swing.UIManager;
import java.awt.*;

/**
 * Title:        Zeichnen und Serialisieren
 * Description:
 * Copyright:    Copyright (c) 2000
 * Company:      Joller-Voss GmbH
 * @author J.M.Joller
 * @version 1.0
 */

public class ZeichnenUndSerialisierenApp {
  static String motif = new
            String("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
  static String metal = new
            String("com.sun.java.swing.plaf.metal.MetalLookAndFeel");

  boolean packFrame = false;

  /**Construct the application*/
  public ZeichnenUndSerialisierenApp() {
    ZeichnenUndSerialisieren frame = new ZeichnenUndSerialisieren();
    //Validate frames that have preset sizes
    //Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    //Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }
  /**Main method*/
  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      UIManager.setLookAndFeel(motif);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    new ZeichnenUndSerialisierenApp();
  }
}